<template>
	<h3>Task: {{ props.item?.name }}</h3>
	<el-form @submit.prevent label-width="240px">
		<el-form-item label="Redmine">
			<input-search
				:model-value="redmineValue"
				@change="val => redmine.id = parseNumber(val)"
				:query-search="redmineQuerySearch"
			/>
			<span>Zakázka: {{ redmine.ifsTaskId }}</span>
		</el-form-item>
		<el-form-item label="IFS">
			<input-search
				:model-value="ifsFirstValue"
				@change="changeFirstId"
				:query-search="ifsQuerySearchFirstPart"
			/>
		</el-form-item>
		<el-form-item label="Pracovní úloha / Náklad projektu">
			<input-search
				:model-value="ifs.secondId"
				@change="val => ifs.secondId = val"
				:query-search="ifsQuerySearchSecondPart"
				:trigger-on-focus="true"
				:disabled="ifsSecondDisabled"
			/>
		</el-form-item>
		<el-form-item>
			<el-button type="primary" @click="submit">Uložit</el-button>
			<el-button @click="() => emit('close')">Zavřít</el-button>
		</el-form-item>
	</el-form>
</template>
<script lang="ts" setup>

import { computed, reactive, ref, watch } from 'vue-demi';
import { ElForm, ElFormItem } from "element-plus";
import { redmineClient } from '../../ts/apis/redmineClient';
import { Either, Task, IfsApiResponseError, IfsProject, IfsTask, IfsWorkOrder, RMTask, TaskEither, TE, IfsWorkOrderOperation, IfsProjectReport, ClickTask, RMSearchTask, IfsTaskType, ClickApiResponse, ClickExternalName, IfsApiResponse } from '../../../lib/types';
import { ifsClient } from '../../ts/apis/ifsClient';
import InputSearch from "../controls/InputSearch.vue";
import { A, AP, pipe, T } from '../../../lib/utils/fptsUtil';
import { ClickupConfig, IfsConfig, RedmineConfig } from '../../../config';
import { getNumber } from '../../../lib/utils';
import { apiResolveOrAlert, apiResolveOrDefault, processUserApiCall } from '../../ts/utils/uiUtil';
import { clickupClient } from '../../ts/apis';
import { TimesheetTask } from '../../ts/types';

type IfsResultTask = Omit<IfsWorkOrderOperation, "name"> | Omit<IfsProjectReport, "name">;

interface Result {
	redmineId: number | null;
	ifsTask: IfsResultTask | null;
}

interface Props {
	item: TimesheetTask | null;
}

const props = defineProps<Props>();
const emit = defineEmits<{
	(e: 'submit', item: TimesheetTask | null): void,
	(e: 'close'): void
}>();

const redmine = reactive<{ id: number | null, ifsTaskId: string | null }>({
	id: null,
	ifsTaskId: null
});
const ifs = reactive<{ firstId: string | null, type: IfsTaskType | null, secondId: string | null, subTasks: IfsSubTask[] | null }>({
	firstId: null,
	type: null,
	secondId: null,
	subTasks: null,
});

const ifsSecondDisabled = computed(() => !ifs.firstId);

const redmineValue = computed(() => {
	return redmine.id === null ? null : `${redmine.id}`;
});

const ifsFirstValue = computed(() => {
	return ifs.firstId === null ? null : `${ifs.firstId}`;
});

watch(() => redmine.id, async (id) => {
	if (!id) {
		redmine.ifsTaskId = null;
		return;
	}

	const zakazka: RMTask | null = await apiResolveOrDefault(redmineClient.getTaskById(id), null);

	redmine.ifsTaskId = zakazka?.zakazka || null;
});

watch(() => ifs.firstId, (newValue) => {
	ifs.subTasks = null;
	ifs.secondId = null;
});

watch(() => props.item, (newItem) => {
	console.log('watch item', newItem);
	if (newItem == null) {
		redmine.id = null;
		ifs.firstId = null;
		console.log('reset dialog');
	} else {
		redmine.id = newItem.redmineTaskId || null;
		ifs.firstId = newItem.ifsTaskId || null;
		console.log('set inuts', redmine.id, ifs.firstId);
	}
})

function changeFirstId(val: string | null) {
	if (!val || val.length <= 1) {
		ifs.firstId = null;
		ifs.type = null;
		return;
	}

	const type: IfsTaskType | null = val[0] === "W"
		? "WorkOrder"
		: val[0] === "P"
			? "Project"
			: null;

	if (!type) {
		ifs.type = null;
		ifs.firstId = null;
	}

	ifs.type = type;
	ifs.firstId = val.substr(1);
}

async function submit() {
	const task: TimesheetTask | null = Object.freeze(props.item);
	if (!task) {
		return;
	}

	const redmineId = redmine.id;
	const ifsResultTask = getIfsResultTask(ifs.firstId, ifs.secondId, ifs.type);

	if (!redmineId && !ifsResultTask) {
		emit("submit", null);
		return;
	}

	// const tasks: ClickApiResponse<boolean>[] = [];
	const externalData = {} as Record<ClickExternalName, string>;

	if (redmineId) {
		externalData.RM = redmineId + "";
	}

	if (ifsResultTask) {
		externalData.IFS = ifsResultTask.id;
	}

	const result = await apiResolveOrAlert(clickupClient.updateTaskExternalIds({
		taskId: task.id,
		externalIds: externalData,
	}), null);

	if (!result) {
		emit('submit', null);
	} else {
		emit('submit', {
			id: result.id,
			name: result.name,
			redmineTaskId: result.redmineId || null,
			ifsTaskId: result.ifsId || null,
		});
	}
}

function getIfsResultTask(firstId: string | null, secondId: string | null, type: IfsTaskType | null): IfsResultTask | null {
	if (!(firstId && secondId && type)) {
		return null;
	}
	switch (type) {
		case "Project":
			const report: Omit<IfsProjectReport, "name"> = {
				id: secondId,
				projectId: firstId,
				type
			};

			return report;
		case "WorkOrder":
			const wo: Omit<IfsWorkOrderOperation, "name"> = {
				id: secondId, // FIXME: udelat nejaky mapper
				operationId: Number(secondId.substr(secondId.lastIndexOf('_'))), // FIXME: udelat mapper
				workOrderId: Number(firstId),
				type,
			};
			return wo;

		default:
			throw new Error(`Type '${type}' is not supported.`);
	}
}

interface QuerySearch<T> {
	transformItem: (a: T) => { value: string; text: string; };
	querySearch: (query: string) => TaskEither<any, T[]>;
}

function ifsQuerySearchFirstPart(): QuerySearch<IfsTask> {
	return {
		transformItem: task => ({ value: `${task.type[0]}${task.id}`, text: `${task.id}[${task.type}] ${task.name}` }),
		querySearch: (query: string) => {
			const top = 5;
			const date = new Date();

			return processUserApiCall("IFS", ({ companyId }) => {
				return mergeFn([
					ifsClient.searchProject({ query, top, companyId, date }),
					ifsClient.searchWorkOrder({
						companyId: companyId,
						query,
						top
					})]);
			});
		}
	}
}

type IfsSubTask = IfsWorkOrderOperation | IfsProjectReport;

function ifsQuerySearchSecondPart(): QuerySearch<IfsSubTask> {
	return {
		transformItem: task => ({ value: task.id, text: task.name }),
		querySearch: (query: string) =>
			TE.tryCatch(async () => {
				const firstId = ifs.firstId;
				const type = ifs.type;

				if (!firstId || !type) {
					return [];
				}

				const items = await getIfsSubTasksCache(firstId, type);

				if (!query) {
					return items;
				}

				query = query.toLocaleLowerCase();
				return items.filter(x => x.name.toLocaleLowerCase().indexOf(query) !== -1 || x.id.toLocaleLowerCase().startsWith(query));
			}, (e) => e)
	}
}

async function getIfsSubTasksCache(id: string, type: IfsTaskType): Promise<IfsSubTask[]> {
	if (ifs.subTasks !== null) {
		return ifs.subTasks;
	}

	const either = await getIfsSubTasksById(id, type)();

	if (either._tag === "Left") {
		ifs.subTasks = null;
		throw new Error(either.left.message);
	}

	ifs.subTasks = either.right;

	return either.right;
}

function getIfsSubTasksById(id: string, type: IfsTaskType): IfsApiResponse<IfsSubTask[]> {
	if (type !== "WorkOrder" && type !== "Project") {
		throw new Error(`ID has bad format.`);
	}

	// switch (type) {
	// 	case "WorkOrder": // work order
	// 		return ifsClient.getWorkOrderOperations({
	// 			companyId: '2',
	// 			workOrderId: Number(id)
	// 		});

	// 	case "Project": // project
	// 		return ifsClient.getProjectReports({
	// 			companyId: '2',
	// 			date: new Date(),
	// 			projectId: id
	// 		});
	// }

	return processUserApiCall<IfsSubTask[], "IFS", IfsApiResponseError>("IFS", ({ companyId }) => {
		switch (type) {
			case "WorkOrder": // work order
				return ifsClient.getWorkOrderOperations({
					companyId,
					workOrderId: Number(id)
				});

			case "Project": // project
				return ifsClient.getProjectReports({
					companyId,
					date: new Date(),
					projectId: id
				});
		}
	})
}

function mergeFn(tasks: TaskEither<IfsApiResponseError, IfsProject[] | IfsWorkOrder[]>[]): TaskEither<any, IfsTask[]> {
	return TE.tryCatch(async () => {
		const s = AP.sequenceT(T.ApplySeq)(...tasks);
		const result: IfsTask[] = await m(s);

		return result;
	}, (e) => e);

	async function m(t: Task<Either<IfsApiResponseError, IfsProject[] | IfsWorkOrder[]>[]>): Promise<IfsTask[]> {
		const eithers = A.separate(await t());
		const result: IfsTask[] = [];

		if (!eithers.right.length) {
			throw new Error("All failed.");
		}

		for (const tasks of eithers.right) {
			result.push(...tasks.map<IfsTask>(task => ({
				id: task.id + '',
				name: task.name,
				type: task.type,
			})));
		}

		return result;
	}
}

function redmineQuerySearch(): QuerySearch<RMSearchTask> {
	return {
		transformItem: itm => ({
			value: itm.id + '',
			text: `${itm.id} - ${itm.name}`
		}),
		querySearch(query: string) {
			return redmineClient.searchTasks({
				query,
				top: 10
			});
		}
	}
}

function parseNumber(val: string | null): number | null {
	return getNumber(val, null) || null;
}

</script>